var
	bt_parents[0]
	bt_children[0]
	bt_tree_datums[0]


BrowserTree_Selector
	var
		bt_select_name = "Select"
		bt_tree_type = ""
		bt_viewer
		bt_params = ""
		bt_showkeys = 0
		bt_name_select = 0
		bt_can_select = 0

	New(x)
		..(x)
		if(ismob(x)) bt_viewer = x
		else if(istype(x,/client))
			var/client/C = x
			if(C && C.mob) bt_viewer = C.mob
		if(bt_viewer)
			var
				Path = (istext(bt_tree_type))?text2path(bt_tree_type)\
				 : (ispath(bt_tree_type))?bt_tree_type : /BrowserTree
				BrowserTree/Tree = new Path
			Tree.bt_Display(bt_viewer,bt_params,bt_showkeys,src)

	proc
		Process(mob/M,selected)
			if(!istype(selected,/list) || !M || !ismob(M)) return
			return ..()




BrowserTree

	New()
		bt_type = "[type]"
		if(initializing) return ..()
		bt_FindRelatives()
		if(bt_parent&&!bt_style_sheet)
			bt_style_sheet = bt_parent.bt_style_sheet
		return ..()

	Del()
		return 0


	var
//Interal Use by BrowserTree procedures;
		tmp
			initializing = FALSE
		BrowserTree/bt_parent = ""
		bt_offspring[0]
		bt_type = ""
//Customization of datum information;
		bt_name
		bt_info
		bt_full
		bt_key
//Customization of color
		//Variable - CSS Counter Part(Recommended)
		bt_background_color  //body    {background: value(color)}
		bt_text_color        //body    {definition(value)}
		bt_back_color        //.Back   {definition(value)}
		bt_close_color       //.Close  {definition(value)}
		bt_link_color        //.Link   {definition(value)}
		bt_key_color         //.Key    {definition(value)}
	//Style Sheet.
		bt_style_sheet
	//Text variable definition.
		bt_text_variables

	parent_type = /obj






	proc

		bt_FindRelatives()
			for(var/Child = 1 , Child <= length(bt_parents) , Child++)
				var/BrowserTree/try_child = bt_parents[Child]
				if(try_child.bt_type == bt_type)
					var/BrowserTree/T = bt_children[Child]
					bt_offspring += T
			for(var/BrowserTree/P in bt_tree_datums)
				for(var/A = 1 , A <= length(bt_parents) , A++)
					var/BrowserTree
						try_child = bt_children[A]
						try_parent = bt_parents[A]
					if("[bt_type]" == try_child.bt_type)
						if("[P.bt_type]" == try_parent.bt_type)
							bt_parent = P
							return


		bt_InitializeChildren()
			if(bt_parent || length(bt_offspring)) return
			for(var/BrowserTree/Children in bt_tree_datums)
				if(Children.bt_type == bt_type) continue
				else if(!(bt_IsChild("[bt_type]","[Children.bt_type]")))
					continue
				Children.bt_SetVariables("[Children.bt_text_variables]")
				var
					TypeType  = "[bt_type]"
					ChildType = "[Children.bt_type]"
					L = length(TypeType)+2
				if(!findtext("[copytext(ChildType,L)]","/"))
					bt_parents  += list(src)
					bt_children += list(Children)



		bt_SetVariables()
			var
				incoming = bt_text_variables
				ToFind = list("name","info","full","key")
				Fix[0]
				Default = {"
<name>[name]</name>
<info>[name][(copytext(name,length(name)) == "s")?"'":"'s"]\
&nbsp;information.</info>
<full>[name][(copytext(name,length(name)) == "s")?"'":"'s"]\
&nbsp;full information.</full>
<key>A</key>
"}
			if(bt_text_variables) incoming = "[Default][incoming]"
			for(var/variable in ToFind)
				var/find = findText(incoming,"<[variable]>")
				while(find)
					var
						end		= findText(incoming,"</[variable]>")
						opentag	= length("<[variable]>")
					if(find && end)
						var/between = copytext(incoming,find+opentag,end)
						if(between == "...")
							Fix["bt_[variable]"] = vars["bt_[variable]"]
						else if(variable=="name" && between=="type")
							var
								T = "[bt_type]"
								F = findtext(T,"/")
								TN = ""
							while(F)
								TN = copytext(T,F+1)
								F = findtext(T,"/",F+1)
							if(TN) Fix["bt_[variable]"] = TN
						else Fix["bt_[variable]"] = between
						incoming = \
						copytext(incoming,1,find) + \
						copytext(incoming,end+length("</[variable]>"))
						find = findText(incoming,"<[variable]>")
					else find = 0
			for(var/Next = 1 , Next <= length(Fix) , Next++)
				var
					A = Fix[Next]
					B = Fix[A]
				vars["[A]"] = "[B]"


		bt_SetStyle()
			var
				incoming = "[bt_style_sheet]"
				css = {"
body   {background: [bt_background_color]; color: [bt_text_color];}
.Back  {color: [bt_back_color];}
.Close {color: [bt_close_color];}
.Link  {color: [bt_link_color];}
.Key   {color: [bt_key_color];}"}
			bt_style_sheet = "[css][incoming]"


		bt_ReplaceVarTags(incoming="")
			if(!incoming) return
			var
				start = "<var>"
				end = "</var>"
				found = findtext(incoming,start)
			while(found)
				var
					stop = findtext(incoming,end,found+length(start))
					between = copytext(incoming,found,stop+length(end))
					replace = \
					 vars["[copytext(incoming,found+length(start),stop)]"]
				incoming = bt_Replace(incoming,between,"[replace]")
				found = findtext(incoming,start)
			return incoming


		bt_Display(mob/M,params,showKeys = 0,BrowserTree_Selector/Holder)
			if(!M) return
			if(M.CurrentBrowserTree)
				M << {"<TT><font color=red>You already have a \
'BrowserTree' window open. Please close that one.</font></TT>"}
				return
			showKeys = text2num(showKeys)
			if(bt_text_variables && istext(bt_text_variables))
				bt_SetVariables()
			if(bt_parent&&!bt_style_sheet)
				bt_style_sheet = bt_parent.bt_style_sheet
			bt_SetStyle()
			bt_name = bt_ReplaceVarTags(bt_name)
			bt_info = bt_ReplaceVarTags(bt_info)
			bt_full = bt_ReplaceVarTags(bt_full)
			M.CurrentBrowserTree = src
			M.Params = params
			M.ShowKeys = showKeys
			if(Holder) M.Holder = Holder
			params = bt_Replace("[params]",";",":")
			params = bt_Replace("[params]","&",":")
			params = bt_Replace("[params]",",",":")
			var/Browse = {"
<head>
  <script>
function send(v) {BYOND.href='BYOND://?src=\ref[M];'+v;BYOND.click();}
  </script>
</head>
<a ID=BYOND href=#></a>
<div class='All' onClick=send('Click')>
"}
			Browse += {"<style type=\"text/css\">[bt_style_sheet]</style>
<span class='Full'>[bt_ReplaceIcons(M,bt_full)]</span><br><br>"}
			if(length(bt_offspring))
				for(var/Count = 1 to length(bt_offspring))
					var/BrowserTree/C = bt_offspring[Count]
					C.bt_SetVariables(C.bt_text_variables)
					if(showKeys)
						Browse += "<span class='Key'>[C.bt_key] </span>"
					Browse += "<a class='Link' href='?src=\ref[M];"
					var/child_len = length(C.bt_offspring)
					if(Holder && Holder.bt_name_select && !(child_len))
						Browse += \
						"Choice=[C.bt_type];HolderType=[Holder]'>"
					else Browse += "Display=[C.bt_type];Params=[params];\
ShowKeys=[showKeys];Holder=[Holder]'>"
					Browse += {"[C.bt_name]</a><br>
<span class='Info'>[bt_ReplaceIcons(M,C.bt_info)]</span><br>"}
			if(!length(bt_offspring))
				if(Holder && Holder.bt_can_select)
					Browse += {"<a href='?src=\ref[M];
Choice=[bt_type];HolderType=[Holder]'>[Holder.bt_select_name]</a>"}
			Browse += "<br>[bt_CalculateBack(M,params,showKeys,Holder)]\
<br>"
			if(showKeys) Browse += "<span class='Key'>X </span>"
			Browse += {"
<a class='Close' href='?src=\ref[M];Close=1'>Close</a></div>"}
			params = bt_Replace("[params]",":",";")
			var/Options = "window=BrowserTree;[params]"
			M<<browse(Browse,Options)
			M<<browse(null,null)



		bt_CalculateBack(mob/M , params , showKeys = 0 , Holder)
			if(bt_parent)
				.="<br>"
				var/BrowserTree/par = bt_parent
				if(showKeys)
					. += "<span class='Key'>Z </span>"
				. += {"<a class='Back' href='?src=\ref[M];Display
=[par.bt_type];Params=[params];ShowKeys=[showKeys];Holder=[Holder]'>
Back</a>"}




mob
	Topic(href,href_list[])
		..()
		if(href_list["Choice"])
			var
				C = href_list["Choice"]
				HT = href_list["HolderType"]
				BrowserTree_Selector/NH
			HT = text2path(HT)
			if(HT) NH = new HT
			src<<browse(null,"window=BrowserTree")
			CurrentBrowserTree = ""
			Params = ""
			ShowKeys = FALSE
			if(length(C) > 14 && NH)
				var/Clist = bt_Split("[copytext(C,14)]","/")
				Clist = bt_SelectorAssociate(Clist)
				NH.Process(src,Clist)
		if(href_list["Close"])
			src<<browse(null,"window=BrowserTree")
			CurrentBrowserTree = ""
			Params = ""
			ShowKeys = FALSE
		if(href_list["Display"])
			src<<browse(null,"window=BrowserTree")
			var
				NewType = "[href_list["Display"]]"
				BrowserTree/D = bt_FindDatum(NewType)
				Params = href_list["Params"]
				ShowKeys = href_list["ShowKeys"]
				Holder = href_list["Holder"]
			CurrentBrowserTree = ""
			ShowKeys = text2num(ShowKeys)
			Holder = text2path(Holder)
			if(Holder) Holder = new Holder
			D.bt_Display(src , Params , ShowKeys , Holder)
		for(var/Part in href_list)
			if(Part=="Click")
				spawn(1) src << browse(null,null)


	var
		BrowserTree/CurrentBrowserTree
		Params = ""
		ShowKeys = FALSE
		BrowserTree_Selector/Holder



	verb
		A()
			set hidden = 1
			bt_Key(src,65)

		Back()
			set hidden = 1
			if(!CurrentBrowserTree) return
			if(!ShowKeys) return
			if(CurrentBrowserTree.bt_parent)
				var/BrowserTree/D = CurrentBrowserTree.bt_parent
				src<<browse(null,"window=BrowserTree")
				CurrentBrowserTree = null
				D.bt_Display(src , Params , ShowKeys)
				return

		Close()
			set hidden = 1
			if(!ShowKeys) return
			src<<browse(null,"window=BrowserTree")
			CurrentBrowserTree = null
			Params = ""
			ShowKeys = FALSE






world
	New()
		..()
		sleep(5)
		for(var/V in typesof(/BrowserTree) - /BrowserTree)
			var/BrowserTree/B = new V
			B.initializing = TRUE
			bt_tree_datums += B
		var
			parts_list = ParseTree("",list("BrowserTree","part"),depth=0)
		for(var/to_add in parts_list["part"])
			var
				BrowserTree/txt_new = new
				vars_search = list("textvars","type","css")
				txt_vars = AttributeListFromText(to_add,vars_search)
			if(!findtext(txt_vars["textvars"],"Parser error"))
				txt_new.bt_text_variables = txt_vars["textvars"]
			if(!findtext(txt_vars["css"],"Parser error"))
				txt_new.bt_style_sheet = txt_vars["css"]
			if(!findtext(txt_vars["type"],"Parser error"))
				txt_new.bt_type = txt_vars["type"]
			txt_new.bt_SetVariables()
			bt_tree_datums += txt_new
		for(var/BrowserTree/tree_part in bt_tree_datums)
			tree_part.bt_InitializeChildren()
		for(var/BrowserTree/tree_part in bt_tree_datums)
			tree_part.bt_FindRelatives()



var/bt_MacrosOn = FALSE

client
	New()
		if(bt_MacrosOn) command_text = ".alt "
		return ..()
#if defined(bt_ScriptOn)
	script = {"
macro
	Z return "Back"
	X return "Close"
	C return "C"
"}
#endif





proc

	bt_SelectorAssociate(list/Old)
		if(!Old || !istype(Old,/list)) return Old
		var/New[0]
		for(var/Place = 1 , Place <= length(Old) , Place++)
			New["[Place]"] = Old[Place]
		return New


	bt_TextFromList(list/the_list, separator)
								      //Modified Deadron's dd_list2text()
		var/total = the_list.len
		if(total == 0) return
		. = "[the_list[1]]"
		for(var/count = 2, count <= total, count++)
			if(separator) . += separator
			. += "[the_list[count]]"

	bt_Split(string, separator) //Modified Deadron's dd_text2list()
		. = new/list
		var/search  = 1
		while(1)
			var/F = findtext(string, separator, search, 0)
			. += "[copytext(string, search, F)]"
			search = F + length(separator)
			if(F == 0) return .
			else if(search > length(string)) return .+""

	bt_Replace(string = "" , search = "" , replace = "")
		var/textList = bt_Split(string, search)
		. = bt_TextFromList(textList, replace)

	bt_ReplaceIcons(mob/M,incoming)
		if(!M) return
		var/p = findText(incoming,"<bt_icon>")
		while(p)
			var
				e = findText(incoming,"</bt_icon>")
				c = findText(incoming,";")
			if(c && e)
				var
					I  = copytext(incoming,p+9,c)
					Is = copytext(incoming,c+1,e)
				if(fexists(I))
					var/Icon = file(I)
					I = bt_Replace(I," ","_")
					I = bt_Replace(I,"/","_")
					M << browse_rsc(icon(Icon,Is),"[I][Is]")
					incoming = copytext(incoming,1,p)+\
					"<img src=[I][Is]"+copytext(incoming,e+9)
				else
					incoming = copytext(incoming,1,p)+\
					copytext(incoming,e+10)
			p = findText(incoming,"<bt_icon>")
		return incoming

	bt_Key(mob/M , Key)
		if(!M || !M.CurrentBrowserTree) return
		if(!M.ShowKeys) return
		var/BrowserTree/Current = M.CurrentBrowserTree
		if(isnum(Key)) Key = "[ascii2text(Key)]"
		for(var/BrowserTree/Next in Current.bt_offspring)
			if(Next.bt_key == Key)
				if(M.Holder && M.Holder.bt_name_select \
				    && !(length(Next.bt_offspring)))
					var/L = list("Choice"="[Next.bt_type]",\
					"HolderType"="[M.Holder.type]")
					M.Topic(,L)
				else
					M<<browse(null,"window=BrowserTree")
					M.CurrentBrowserTree = null
					Next.bt_Display(M , M.Params , M.ShowKeys)
				break

	bt_IsChild(parent, try_child)
		var/pl = copytext(parent,length(parent))
		if(pl != "/") parent += "/"
		var/f = findtext(parent,"/")
		while(f)
			if(f > length(try_child))return 0
			var
				pc = copytext(parent,1,f)
				tc = copytext(try_child,1,f)
			if(pc == tc)
				parent = copytext(parent,f+1)
				try_child = copytext(try_child,f+1)
				f = findtext(parent,"/")
			else
				return 0
		return 1


	bt_FindDatum(datum = "/BrowserTree")
		if(!(istext(datum))) return 0
		for(var/BrowserTree/part in bt_tree_datums)
			if(part.bt_type == datum) return part