/* ALL RIGHTS RESERVED  2005 Polaris8920, BYOND and DanTom.

This is demo/library. You are free to include any of its contents
in your projects. Its contents are not for usage in your own library
demo unless credit is given where credit is due. You may not claim it
as your own or imply it as your own in any way. If you do include it
in you own project, please give credit to Polaris8920 where credit
for this project is due. Credit is not due, if you use this as an
idea for your system, but if you use this and modify it, credit would
still greatly be appreciated.

    ~ Polaris8920


 - Best viewed with tab size 4.



************************HELP AND EXPLINATIONS************************

   During this explanation, I will frequently use the terms parent
and child. This library is not an overrated Sims game. It is just
something to aid in the creation of help files etc. The term parent
refers to the current datum's type, minus itself. The child is the
the current datum's type, and anything directly below.
  ex:
  /BrowserTree/Help           //Parent of /BrowserTree/Help/HowToPlay
  /BrowserTree/Help/HowToPlay //Child of /BrowserTree/Help

var
	bt_parents[0]		Do we have parents?
	bt_children[0]		If we have parents, do we have children?
	bt_tree_datums[0]	This contains a list of all BrowserTree datums.
						We can reuse these by having a variable and using
						bt_FindDatum() to get the correct datum for user
						viewing. Example:
							var
								dat="/BrowserTree/files/longtypepath/help"
								BrowserTree/help = bt_FindDatum(dat)
							help.bt_Display(a_user_mob)


BrowserTree_Selector			This is a datum that allows for quick
								and easy displaying of /BrowserTree
								datums and the datum that will process
								the information sent from a displaying
								BrowserTree datum when a player selects
								something if selecting is active.

	var
		bt_select_name = "Select"	This can be overridden to change the
								selection text of a /BrowserTree to
								display.

		bt_tree_type = ""		This is either a text string or a type
								path that is the /BrowserTree datum to
								display.

		bt_viewer				This is set during
								BrowserTree_Selector/New() and indicates
								what mob is viewing the datum's
								/BrowserTree datum.

		bt_params = ""			These are preprogrammed paramiters that
								are used when showing the current datum's
								/BrowserTree datum to a mob.

		bt_showkeys = 0			This is a boolean variable that indicates
								whether keycodes will be active when the
								datum's /BrowserTree datum is displayed.

		bt_can_select = 0		Another boolean variable that indicates
								if the datum's /BrowserTree datum will be
								used as part of a selection system.

	New(x)						New() has been changed to allow quick
								access to show a /BrowserTree to a player.
								simply preprogram a /BrowserTree_Selector
								and then call
								new/BrowserTree_Selector/your_type(mob) and
								the engine will display the preprogrammed
								/BrowserTree to that mob.

	proc
		Process(mob/M,selected)	This is used to process data sent from a
								/BrowserTree datum when a player has
								selected an option when selection is on.
								The information is accessed as a tree
								that allows for easy manipulation. It can
								easily be used in a series of if()
								statements to check what action to take.
								This tree information is provided in a
								list (selected). Instead of the usually
								way of accessing the tree list through
								an index, it can be accessed via
								selected["number"] instead of
								selected[number]. Notice the quotes. If
								you use the traditional way, then you would
								have to include a way to check if that
								index exists, whereas when you use quotes
								along with the enigine's modification to
								the list, if the index does not exist it
								will appear as null. This way, if you are
								comparing it to a text string,
								IE: selected["1"] == "test", and the index
								does not exist, it will fail the if()
								statement and not create any errors. The
								system also removes /BrowserTree from the
								start of the type string and the split the
								remaining string up by "/". See Demo.dm
								for an example.


BrowserTree						This is our BrowserTree datum.
								See demo on how you can make a
								BrowserTree tree.

	New()
								In this New(), we check if the datum
								is currently initializing/populating
								the bt_parents[0] and bt_children[0]
								lists. If it is, then it returns ..().
								If not, it sets bt_parent it's parent
								datum. Then if it is a parent itself,
								it adds all of it's children's datums
								variable bt_offspring[0].

	var

		tmp
			initializing = FALSE	This is used during
								BrowserTree.New() to check if the
								datum
								is currently populating bt_parents[0]
								and bt_children[0]. I would suggest
								that you not modify it, unless you
								don't want the datum to have a parent,
								or offspring.

		BrowserTree/bt_parent = ""	This is the variable that defines a
								BrowserTree datum's parent. It will
								be in the form of text like a type
								path. An example would be;
								bt_parent = "/BrowserTree/".

		bt_offspring[0]			This is the variable that defines a
								BrowserTree datum's children. It will
								be in the form of a list with text
								like
								a type path. An example would be;
								bt_children = list(\
								"/BrowserTree/User/Jimmy/",\
								"/BrowserTree/User/Joe/")

		bt_type					This is the type of the datum in a text
								string. It is used in place of "[type]"
								because some datums have a psuedo type
								since the were loaded from a text file
								and are just a plain /BrowserTree datum
								with a different bt_type variable.

		bt_name					The parents probably want to give
								identity to it. This will also
								be displayed when going further
								into the BrowserTree tree.


		bt_info					This variable will show up while we
								are looking through our tree under-
								neath the child's name.

								ex:

								My Child            //bt_name
								This is my child.   //bt_info


		bt_full					This variable will show up when we
								are looking at that specific sub-
								category. If we are looking at a
								datum called Parent with a child
								called Child, it would be:

								   I am a parent!//Parent's bt_full

								Child            //Child's bt_name
								I am a child!    //Child's bt_info

		bt_key					This is the variable defined what key
								should be pressed to select this
								datum. This should be in text.




								These are the customizable colors.
								The color settings displayed will
								depend on the datum you are looking
								at. Even if your current datum's
								child's bt_link_color may be redish,
								if your current datum's bt_link_color
								is greenish, the child's link will
								be in green.
								This rule applies to all color
								cutomization variables, and all
								customizable colors should be in
								rgb() or hexadecimal format.

		bt_background_color		Our datum background color.


		bt_text_color			Text color, which is what the text
								besides Back, Close, and child link
								texts will be in.


		bt_back_color			This is what color our Back button
								will be.


		bt_close_color			This is what color our Close buttom
								will be.


		bt_link_color			This is what color our child links
								will be in. Remember, this does not
								change Back or Close.

		bt_key_color			This is the color that the text
								showing what keys can be pressed to
								select a datum will be in.


		bt_style_sheet			This is a variable that can be left
								blank, you may not need it, but you
								can use it to customize the datum's
								appearance. It should be in the form
								of a text Cascading Style Sheet (CSS),
								see Demo.dm for an example
								This is a counter part of,
								bt_text_variables, and if both are fully
								defined, you will only need those two
								variables for full information and color
								customization.

		bt_text_variables		This is a variable that can replace the
								variables bt_name, bt_info, bt_full, and
								bt_key. To do this, simply put the variable
								definitions enclosed in the correct HTML-
								like tags. Example;
								BrowserTree
									MyTree
										bt_text_variables = {"
										<name>My Tree</name>
										<info>Some info.</info>
										<full>Right. Full info...</full>
										<key>A</key>"}
								If properly used with bt_style_sheet, you
								will only need these two variables for full
								information and color customization. See
								Demo.dm for an example.



	proc

		bt_FindRelatives()
			This is used to add the appropriate datums to the datum's
			offspring list and find the correct datum to be used as the
			datum's parent. By default is called by /BrowserTree.New()

		bt_InitializeChildren()
			This is the proc made to put parents in the bt_parents
			list, and children in the bt_children list.
			The proc loops through ever type of datum, minus the
			datum itself.
			In this way it can be read by looping through the parents
			and checking if a datum is that parent. If it is,
			go the same length into the children and use that child.
			This can be reversed to find a child's parent by looping
			through the children, matching them, and then going the
			same distance into the parents. You do not need to overrite
			or modify this proc, nor do you need to call it, just leave in
			the current world/New() overrite to initialize all of the
			datums.

		bt_SetVariables(incoming)
			This is an internal proc used by the BrowserTree processor to
			associate the bt_text_variables to their correct variables.
			This parses for HTML-like tags indication name, info, full
			and/or key. Then, the datum's variables will be set
			accordingly. You do not need to overrite or use this in any
			other place besides bt_Display().

		bt_SetStyle()
			This will only be called by the interal system if the current
			datum already has a style sheet. It will add any other color
			variables to the style sheet and return the new one for interal
			processing.

		bt_ReplaceVarTags(incoming="")
			This is called by /BrowserTree.bt_Display() to replace all
			<var>VarName</var> tags with the appropriate variable that
			the datum has. <var>bt_name</var> would be replaces with the
			datum's bt_name variable.

		bt_Display(mob/M , params , showKeys, Holder)
			This is proc used to browse a datum.
			You can display a datum to a mob by doing something as
			simple as this:

			mob/verb/Help()
				var/BrowserTree/Help/H = new()	//Make a new pre-
												//programmed help
												//file for them.
				H.Display(src)					//Show it to them.
				del H							//Trash it after.

			The params variable is equivalent to the paramiters that
			the BrowserTree datum will display during browse. An
			example would be datum.Display(mob , "size=500x500")
			The showKeys variable is to show if the user can use
			certain shortcut keys.

		bt_CalculateBack(mob/M , params , showKeys)
			This is used in
			BrowserTree/Display(var/mob/M , params , showKeys)
			to make the Back button.
			The proc checks if it has a parent, then makes the button
			that sends them to their parent.



mob
	Topic(href,href_list[])	This Topic() proc is needed for when we
							activate our links, like to access a
							datum's child, or to go back, or close the
							browser window.

	var

		BrowserTree/CurrentBrowserTree = ""	This is used to store the
								datum that the user is currently browsing.

		Params = ""				This is the text string of paramiters
								to be passed on to a datum if a user
								goes further into the BrowserTree
								structure.

		ShowKeys = FALSE		This is the boolean variable to check
								if the key commands will show. If it
								is set to TRUE and the user continues
								further into the BrowserTree datum,
								then all key commands will keep
								showing.

		BrowserTree_Selector/Holder	This is a datum that will process what
								a user selects in certain situations.

	verb

		A()						This is used as a verb for the default
								selection value.

		Back()					This is the default hidden verb that
								is accessed by the back macro to
								activate the user going back.

		Close()					This is the default hidden verb that
								is accessed by the close macro to
								activate the user closing.



			Initialization.
				This is needed for the whole BrowserTree to work. We
				loop through every type of /BrowserTree except
				/BrowserTree itself, because we don't want people to
				be able to return to the blank datum where they would
				be able to view and tree. We don't want this, because
				if we have them using a help file, then they keep
				going back, and back, and back, soon they will get to
				our base /BrowserTree. Now if we also had a datum
				called /BrowserTree/SecretCheatCodes, we would not
				want our nosy little players to be able to access
				that from simply opening a help file.
				So looping through our datum types, we make a new
				type so we can see all of its variables without
				errors.
				Now that we have all of these BrowserTree types, we
				make them find their long lost children. We don't
				need to check for parents, because our parents will
				check for us.
				Then once we've found our new family tree, we kill
				all of us.

world
	New()
		..()
		sleep(5)
		for(var/V in typesof(/BrowserTree) - /BrowserTree)
			var/BrowserTree/B = new V
			B.bt_InitializeChildren()
			del B


var
	bt_MacrosOn = FALSE			This is a variable that if set to
								TRUE, will set client.command_text
								to ".alt " activating macros.

client/New()					This has been overwritten to modify
								client.command_text if bt_MacrosOn is
								set to TRUE.


client/script					This has been modified to support the key
								codes. It currently has the macros Z and X,
								which are used for navigating back through
								the datum, and closing the datum.


proc

	bt_SelectorAssociate(list/Old)
			This is used to process a list and return all of it's indexs
			with text indexs for interal usage.

	bt_TextFromList(list/the_list, separator)
			This is a modified version of Deadron's dd_list2text() which
			can be found in his TextHandling library.

	bt_Split(string, separator)
			This is a modified version of Deadron's dd_text2list() which
			can be found in his TextHandling library.

	bt_Replace(string , search , replace)
			This will parse through the string and replace all instances
			of search with replace. This is used in bt_ReplaceIcons() and
			bt_Display().

	bt_ReplaceIcons(mob/M,incoming)
			This is used during BrowserTree/Display(mob/M) to filter
			through the current datum's bt_full variable and all of
			the current datum's children's bt_info variable and
			replace "<bt_icon>icon;icon_state</bt_icon>" with
			"<img src=[icon][icon_state]>". But before it does this,
			it uses browse_rsc() to send the icon to M's icon cache.
			After it filters all of the icons, it returns the
			incoming variable text string.

	bt_Key(mob/M,Key)
			This is used if you want key commands when displaying the
			BrowserTree datum. To modify if keys are on or not just
			do something like this;

				var/BrowserTree/Help/H = new()	//Make a new pre-
												//programmed help
												//file for them.
				H.Display(src,,1)				//Show it to them.
												//With the third
												//setting, showKeys
												//on. So it will use
												//key commands.
				del H							//Trash it after.

			To make a BrowserTree datum, and all of its children, have
			a key command associated with them, just modify
			BrowserTree/bt_key. See Demo.dm for an example.

	bt_IsChild(parent, try_child)
			This takes two text strings as an argument. They are in the
			form of a typepath. They do not need to be real typepaths.
			The procedure will return if the try_child text string is a
			subtype of the parent text string.

	bt_FindDatum(datum = "/BrowserTree")
			This is used to return a datum from bt_tree_datums. It loops
			through the list of datums and finds the datum with the
			correct bt_type value. This way you can display a datum that
			was loaded from a .txt file. If you tried to loop through the
			list yourself and looked at the type you wouldn't be able to
			do this. You can still create new datums, but then you can't
			display trees from .txt files. So this is the best way to go.
*/